///
/// This gulpfile is for transpiling `babelator`'s code.
///

//region Imports
var gulp = require('gulp')
var gutil = require('gulp-util')
var del = require('del')
var babel = require('gulp-babel')
//endregion

const srcGlob = './src/**/*.js'

gulp.task('clean', del.bind(null, './lib'))

gulp.task('compile', function() {
  return gulp.src(srcGlob)
    .pipe(babel()) // Will use `.babelrc` by default.
    .pipe(gulp.dest('./lib'))
})

gulp.task('build', gulp.series('clean', 'compile'))

gulp.task('watch', gulp.series('clean', 'compile', function watcher() {
  gulp.watch(srcGlob, gulp.series('compile')).on('change', function(file) {
    gutil.log('---')
    gutil.log('File changed:', gutil.colors.red(file))
  })
}))
